# Talon User's Guide

## Introduction to Talon

Talon is a program written in python language that generates random instruction sequences related to chip instructions based on configuration files.

The tool is used in the chip verification process to generate random instruction sequences related to the chip instructions for verifying the stability and correctness of the chip during operation. Since the chip instruction parameters are ever-changing and the instruction combinations are endless, it is necessary to generate as many and as wide as possible instructions for chip verification and problem location. The tool can then generate the required test instruction sequences.

This tool is written and executed in easy-to-use python language, taking into account the mainstream System Verilog random use case generation idea, using a more flexible random approach and covering a higher breadth of random for use case generation. In addition, many common random range operators for use cases are defined, which greatly facilitates the generation of constraints, and the custom random ranges and random sequences can be saved in a custom configuration file, which is convenient for subsequent use case recurrence and expansion.  For the instruction definition level, we save all the instruction information in an Excel table, which will contain the binary code of the instruction, special encoding rules, and the function type and architecture type of the instruction, greatly improving the efficiency of instruction maintenance and reducing the sensitivity of the script to instructions, which can easily generate any custom instructions.

The output of the tool is a normal C file that can be compiled directly with the toolchain. The normal compilation allows the hardware to execute the file for verification as if it were a normal application.

## Talon setup

### Dependency Package Installation

- **xlrd**

  Talon needs xlrd package for reading .xlsx files.

```
$pip3 list | grep xlrd     //check if it has been installed.
$sudo pip3 install xlrd==1.2.0
```

- **antlr4-python3-runtime**

  The antlr parsing tool for dsl (domain specific language).

```
pip3 install antlr4-python3-runtime -i https://pypi.tuna.tsinghua.edu.cn/simple/
```

### Environment variable setting

- **$PROJ_ROOT**

- **$PATH**

  ```
  export PATH=${PROJ_ROOT}/output/gcc/bin
  ```

## Talon workflow

The workflow for verification using talon is as follows:

![](assets/Talon_User_Guide/talon_workflow.png)

First use talon to generate the c file according to the configuration file, then use gcc to compile the c file into an elf executable, and finally use spike to run the generated executable, which can be debugged according to the log file generated when running spike.

### Generate .c files from .talon configuration files

Run the talon.py script in the $talon_dir path, e.g.

```
python3 talon.py -x instructions.xlsx -o test/push_pop.c -c config/push_pop.talon
```

- -x:  The path of instructions.xlsx file. 
- -o: The output path of the generated c-file.
- -c: The path of the configuration file used. The example uses the .talon configuration file.

In addition to the above three parameters, talon.py can also parse other parameters, please run python talon.py to see the specific usage information.

### Generate .elf file from .c file

Use gcc to compile the c file into an elf executable. Makefile is available under $talon_dir, run the following command to invoke gcc to compile the c file. Where cfile=... refers to the path of the c file being compiled.

```
make com_c cfile=test/push_pop.c
```

Note that the default com_c compile option automatically optimizes the assembly code in the c file, for example, the sw and lw instructions are optimized to compressed 16-bit instructions, where the 16-bit offset is a multiple of 2 and the 32-bit offset is a multiple of 4. This can cause the spike to run with the wrong pointer pc and not produce the desired result. The Makefile includes the option com_c_talon (which differs from com_c specifically by adding the -march=rv32imafv option to the gcc command to turn off automatic compiler optimization) for unoptimized compilation.

### Run the generated elf file with spike

```
spike -d --isa=rv32imfcv ++set_orv32_rst_pc=0x80000000 ++test/jal_bran_c_files/push_pop.c.elf ++load_pk ++log_step=beak |& tee spike.log
```

Note that the elf file generated by the com_c compilation defined in the Makefile is named $filename.c.elf

If there is a problem with the generated test case, spike may not stop running, please ctrl+c to terminate the run and compare spike.log with the generated c file to investigate the problem.

to do :add Writing scripts to implement the method

to do :add The process of generating a large number of elf using scripts 

## Introduction to instruction definition file

The file instruction.xlsx defines the specific format of various types of instructions in different ISAs, including the binary encoding rules for instructions, encoding ranges, parameter positions and types, and instruction set architecture types.

The Talon will parse the configuration file from the Excel file. You need to refer to this table when writing the configuration file.

### Product Definition

The Excel sheet has a worksheet named **product**, and the string in the first cell defines the product type. If no product is defined, the register will not be constrained.

### Domain Definition

Instructions on the same worksheet are of the same type. **must**

The name of the worksheet **must** be something like *load-L*, where *load* is the name of the instruction type and *L* is the *sequence id* of the instruction type. The name is case-sensitive, as shown below.

*I* cannot be used as a sequence id, because it is an id that is considered an illegal command.

![](assets/Talon_User_Guide/inst_def_1.png)

A typical worksheet is shown below:

![](assets/Talon_User_Guide/inst_def_2.png)

The first row in the worksheet **must** be the definition field. For example, the following is the definition field of computation-U for RV32I

| ISA  | Instructions | Definition | func7[31:25] | inst[24:20] | inst[19:15] | func3[14:12] | inst[11:7] | opcode[6:5\|4:2\|1:0] |
| :--- | :----------- | :--------- | :----------- | :---------- | :---------- | :----------- | :--------- | :-------------------- |
|      |              |            |              |             |             |              |            |                       |

where `ISA` and `Instructions` are **required fields**. If no function check is declared, the column to the right of `instruction` is the instruction field. `Definition, func7[31:25], inst[24:20], inst[19:15], func3[14:12], inst[11:7], opcode[6:5|4:2|1:0]`, etc. are **optional fields**.

The domain of the instruction format **must** be similar to `func7[31:25]`. Where `func7` is the default name of the domain, if the column value of the instruction in `func7` is a fixed value, then `func7` will be the domain name of the instruction in the corresponding column. Otherwise the name defined in the instruction will be used (e.g. rd/rs, etc.).

[] must be used for the bit range definition. If the field func7 is a multi-bit merge, then | must be used for the bit range definition separating each column, e.g. 31|30:28: where 31 is the target bit of the first column and 30:28 is the target bit of the second column, ranging from bit 30 to bit 28. The higher bits must precede the lower bits.

Multiple field formats can be defined in the same worksheet by adding field definition rows to separate the field formats.

### Instruction Definition

Each line under the domain definition line will be treated as a command matching the domain format.

1. The first word separated by a space will be considered the name of the instruction, and the subsequent words will be considered the parameter format of the instruction. Example: The string placed in the line under the domain definition in the `Instructions` column, i.e. `addi rd, rs1, s-imm12`. `addi` is the name of the instruction, and `rd, rs1, s-imm12` is the parameter format of the instruction.
2. All parameter formats **must** be defined in a field with a bit range. For example, the `rd, rs1, s-imm12` field is defined as follows.

```
"rd" = inst[11:7] 
"rs1" = inst[19:15] 
"s-imm12" = func7[31:25] | inst[24:20] 
```

## Introduction to .talon

### How to write a .talon file

The .talon configuration file can generate random tests for one class of instructions or sequential instructions. Testers can write profiles according to their needs. You can start with the overall framework and refine the local content later.

A reference idea for building the overall framework is as follows

First, determine whether the content to be tested has strict requirements for the order of instruction execution.

- If a strict order of execution is not required, i.e., the execution of instructions in a chaotic order does not affect the verification results, such as the verification of a large class of computational-U class of computational instructions, then it is sufficient to specify the instruction type in the sequence.

- If a strict execution order is required, such as stack-in/stack-out operations, then it is necessary to (i) determine which instructions are used and write each of these instructions as an instruction, and (ii) use these instructions to form a sequence of instructions in the execution order required by the design, and (iii) splice between sequences to form a new sequence. The sequences can be concatenated to form new sequences.


Finally, the test is generated based on the sequence of sequences.

The next step is to refine the overall framework that is organized, adding constraints, dependencies.

Reference ideas for refining the local content can be cut from the following points.

- Write function function

- write dependencydependency

- write constraintsconstraint


The return value of a function is a string, which can be a specific register name reg, offset/imm, or a label for a jump, or a complete instruction. dependency adds the corresponding dependency to the specific instruction being tested. constraint adds a size range to the specific value.

The details of writing configuration files are discussed in more detail below.

Please refer to appendix about the specific format of the command.

#### Example 1. Implementing a highly customizable test vector starting from instruction

**Write an instruction**

When you want all test commands to be generated as you expect, you can refer to the full custom command idea. This idea is written with instruction as the smallest unit, and different arrangements of instruction can form a sequence, and finally use test_case to generate the sequence into the desired test code.

Let's start with an instruction. The most basic assembly instructions are add, addi, mul, sub, etc.

add rd, rs1, rs2 in RV32I

For example, we want to write the instruction add x3, x1, x2, i.e. x3=x1+x2, where rd=x3, rs1=x1, rs2=x2.

Then the configuration file can be written as

```
/// This is an add instruction whose rd, rs1 and rs2 are set to reg x3, x1 and x2 
instruction add_demo "add" "rd=x3,rs1=x1,rs2=x2"

/// create a vld.v instruction with specified vd, s-imm12 and rs1 (all functions)
instruction ins1 "vld.v" "vd=func_vd,s-imm12=func_imm,rs1=func_test"
```

**Construct sequences**

We can think of sequences as sequences of instructions. A sequence can be constructed from several instructions, or by choosing to specify a type, or by mixing instructions, types and functions, and sequences can be aligned with each other to construct new sequences.

```
sequence seq1 "sort" ["L","U",ins1,func_slt] [2] /// load-L, computational-U, ins1, slt (function def above) in random order. Twice 
sequence seq2 "choose" ["S","R"] [2]             /// select within store-S, csr-R categories. Twice  
sequence seq2 "ordered" [seq1,seq2] [1,2]        /// concatenate seq1 and seq2 in order. Generate 1-2 times
```

**Construct test case**

Create two test cases that use the same ISA with seq2, and add different property constraints to both.

```
/// create 2 test cases 
test_case test1 seq2 ["RV32IMC","Zicsr","Vector_alu"]     ///include type RV32IMS, Zicsr, Vector_alu instructions (refer to excel)
test_case test2 seq2 ["RV32IMC","Zicsr","Vector_alu"]
```

#### Example 2. Fine-grained constraint control using functions

Because the functions follow python syntax, you can use random functions, if else statements, etc. to return different values based on different conditions.

```
////// test1:return the vector register v0, for the vld destination reg 
def func_vd(): {
    return "v0"
}
////// test2:return an offset number 
def func_imm(): {
    global ran1
    ran1 += 1
    return "%d" % (ran1 + offset_cnt * 5)
}
////// test3:return slt instruction
def func_slt(): {
    return "asm volatile (\"slt ra, t3, s2\\n\\t\");"
}
////// test4:return a random reg name,either ra or t0
def func_jalr_rs_cons(): {
    from random import choice
    List=["ra","t0"]
    rs = choice(List)
    return rs
}
////// test5:return a asm instruction,which gives a label
def func_label_generate(): {
    global rand_i
    rand_i += 1
    return "asm volatile (\"label%d: \\n\\t\");" % (rand_i)
}
```

The return value of function is a string, so it can return a register string as a constraint, or it can return an assembly instruction directly.

When writing instruction, we may want to use different registers according to different situations, or select registers randomly each time, etc. In this case, we can use function function to generate randomly selected registers, refer to test4 above.

Another important function is to generate several lines of instructions, see test3 and test5.

### Talon code example

The following code is a more complete talon configuration file for reference.

```
/// include an external .talon file like C language 
include config/rv32/test1.talon                

/// set dep1 rule, rd should ...
dependency dep1 "rd=rs1[3];rs1=rd[3:0]"

/// set con1 rule, the number 1948<[]<=2048 or 
constraint con1 "[]<=2048,[]>1948;[]==6|7"

/// initialize two globle variables 
randint ran1 [0,3]
randint offset_cnt [5]

/// define three functions 
////// return the vector register v0, for the vld destination reg 
def func_vd(): {
    return "v0"
}
////// return an offset number 
def func_imm(): {
    global ran1
    ran1 += 1
    return "%d" % (ran1 + offset_cnt * 5)
}
////// return slt instruction, directly a full instruction str 
def func_slt(): {
    return "asm volatile (\"slt ra, t3, s2\\n\\t\");"
}

/// create a vld.v instruction with specified vd, s-imm12 and rs1 
instruction ins1 "vld.v" "vd=func_vd,s-imm12=func_imm,rs1=func_test"

/// create test sequences 
sequence seq1 "sort" ["L","U",ins1,func_slt] [2] /// load-L, computational-U, ins1, slt in random order. Twice 
sequence seq2 "choose" ["S","R"] [2]             /// select within store-S, csr-R categories. Twice  
sequence seq2 "ordered" [seq1,seq2] [1,2]        /// concatenate seq1 and seq2 in order. Generate 1-2 times

/// create 2 test cases 
test_case test1 seq2 ["RV32IMC","Zicsr","Vector_alu"]           ///include type RV32IMS, Zicsr, Vector_alu instructions (refer to excel)
test_case test2 seq2 ["RV32IMC","Zicsr","Vector_alu"]

/// add properties for the test cases 
let test1 add_constraint "L>>>RV32I>>>s-offset" con1               /// set con1 to the load-L, RV32I ISA, s-offset 
let test1 range_opcode_for "U" "with" "vadd.vv,vsub.vv,vmerge.vv"  /// modify U type instruction, only generate vadd.vv,vsub.vv,vmerge.vv
let test1 add_dependency dep1                                      /// add dep1 to test_case test1
let test1 set_random_seed 1234                                     /// set the random seed 
```



## Appendix

### Talon DSL Command

- The instruction (set) types (Domain) are U, J, B, L, S, V, P, F, O, E, M, R, etc. In addition, an I is added to indicate illegal instructions.


- ISA type (ISA_Type) has RV32I, RV32F, RV32D, RV32Q, RV32C, RV32F, exclude-RV32C, RV64I, RV64D, RV64C, RV64F, RV64Q, Vector_alu, etc. Please refer to talon/instruction.xlsx for details.

#### **Include**

Used to include other talon files. Variables and functions defined in the included talon file can be referenced. 

Example:

```
include config/rv32/test1.talon    ///include an external .talon file like C language
```

#### **Def function**

Used to define functions, following python 3 syntax. Note that the function body must be enclosed in a pair of {}. (Note that func does not currently support passing parameters!）

Note: The return value of a function definition must be a string (even if it is a numeric value it must be formatted as a string).

Example:

```
////// test1:return the vector register v0, for the vld destination reg 
def func_vd(): {
    return "v0"
}
////// test2:return an offset number 
def func_imm(): {
    global ran1
    ran1 += 1
    return "%d" % (ran1 + offset_cnt * 5)
}
////// test3:return slt instruction
def func_slt(): {
    return "asm volatile (\"slt ra, t3, s2\\n\\t\");"
}
////// test4:return a random reg name,either ra or t0
def func_jalr_rs_cons(): {
    from random import choice
    List=["ra","t0"]
    rs = choice(List)
    return rs
}
////// test5:return a asm instruction,which gives a label
def func_label_generate(): {
    global rand_i
    rand_i += 1
    return "asm volatile (\"label%d: \\n\\t\");" % (rand_i)
}
```

#### **Instruction**

Used to define an imperative variable. (Instruction variables are available in sequence).

**Format:** 

​		instruction Name Instr Para

**Parameter**:

- Name: the name of the instruction type variable.

- Instr: instruction.

- Para: the value of the parameter taken in Instr instruction format.

**Note**: 

- Unlike constraint, when defining the segment of the register here, if the rd register is defined as x1(ra), it should be written as rd=ra, and cannot be assigned by number.
- For instructions like jalr, with ISA type exclude-RV32I, they need to be defined directly with the instruction type.

**Example**:

```
/// This is an add instruction whose rd, rs1 and rs2 are set to reg x3, x1 and x2 
instruction add_demo "add" "rd=x3,rs1=x1,rs2=x2"
/// create a vld.v instruction with specified vd, s-imm12 and rs1 (all functions)
instruction ins1 "vld.v" "vd=func_vd,s-imm12=func_imm,rs1=func_test"
```

#### **Sequence**

Used to describe the range, manner and number of random selections of the instruction , etc.

**Format**: 

​	sequence Name RandomType Domain RandomRange

**Parameters**:

- Name: sequence variable name.

- RandomType: string, command type random selection method, case-sensitive. The range of values is as follows.
  - "sort": random sort order using shuffle.
  - "ordered": order according to the list of instruction types.
  - "choose": use choice to randomly select one from the list of instruction types, i.e., in the given list, only one instruction type is selected for generation.

- Domain: A string composed of, a list of instruction types, either of a certain type (U, J, B, L, S, V, P, F, O, E, M, R), an instruction type variable (please refer to the Instruction section), a function name (please refer to the Def function section), or a combination of all three. For example, ["L", "U", "S",ins1,func_slt]. Where ins1 is an instruction type variable and func_slt is a function name.

  When the function is called to return directly to the instruction the format is as follows (note that currently func does not support passing parameters!)

  ```
  def func_slt(): {
      return "asm volatile (\"slt ra, t3, s2\\n\\t\");"
  }
  ```

- RandomRange: list type, how many times the command generates randomly. If a number is specified, the specified number of times is generated. If a range is specified, then a random integer within this range is generated. For example, [50], [10, 30].

**Note**: 

​	If the sequence here is I, it means generate illegal instruction, which means generate test_case list.

**Example**:

```
sequence sq "sort" ["S"] [100]

sequence seq1 "sort" ["L","U"] [2]

//Generate twice, each time choosing a list randomly among S and R.
sequence seq2 "choose" ["S","R"] [2]

//Let the seq2 before the assignment be seq2_old and the seq2 after the copy be seq2_new, then we have: seq2_new=seq1+seq2_old
sequence seq2 "ordered" [seq1,seq2] [1,2]
```

#### **Dependency**

Used to define the dependencies used by segment in the directive.

**Format**:

​	dependency Name Depstr

**Parameters**:

- Name: the name of the dependency variable.

- Depstr: string specifying the Dependency details.

**Description**:

- The string Depstr is in the format "dst=src[m:n]" and each dependency string must be in this format. Where.
  - dst is the dependency.
  - src is the dependency source.
  - m:n is the dependency range, i.e., a random number is generated in the m:n range using the choice method to indicate how many commands dst depends on the src of the previous command.

- Multiple Depstr strings are separated by ";", e.g. "a=b[m:n];c=d[x:y]".

**Note**:

- Each dependency string can, and must, contain only one =, one :, and one pair of []. m, n must be numbers.

- m, n must be numbers. m, n size order is not required, the tool will sort internally. I.e., [m:n] and [n:m] are equivalent, in fact both are [min(m,n) : max(m,n)].

**Example**:

```
dependency dep1 "rd=rs1[2];rs1=rd[3:0]"
```

#### **Constraint**

Used to define constraints. Note that the constraints defined here must be added to the corresponding test_case by the add_constraint of the let command to take effect.

**Format**:

​	constraint Name Constraint

**Parameters**:

- Name: the name of the constraint type variable.

- Constraint: constraint.

**Description**:

- The syntax rules for the constraint file are shown in the following table.

| **Mark** | **Scope**  | **Function Introduction**                                    |
| :------- | :--------- | :----------------------------------------------------------- |
| []       |            | Represents the constrained variable. If no specific bit width is included, the default is the entire variable. |
| :        | []external | Constrains the bit-width range of the variable，  [4:0] indicates bit0 to bit4. |
| \|       | []internal | Constrains the bit-width range of the variable，4 \| 0 means bit0 or bit4. |
| \|       | []external | Exists in an equation that can be used primarily to define multiple assignment cases, such as [] == 5. |
| ,        | []external | The union of multiple constraint expressions.  ([]<4, []>0) denotes []<4 and []>0 |
| ;        | []external | The union of multiple constraint expressions. ([]>4; []<0) means []>4 or []<0. When both ";" and "," are present, ";" has higher priority, i.e. the expression will be divided into multiple fields based on ";" is divided into multiple fields. If a field contains more than one "," then all the conditions in it need to be satisfied. |
| >        | []external | Greater than                                                 |
| >=       | []external | Greater than or equal to                                     |
| <        | []external | Less than                                                    |
| <=       | []external | Less than or equal to                                        |
| ==       | []external | equal to                                                     |
| !=       | []external | Not equal to                                                 |
| eval     | []external | After the instruction is generated, the final value is obtained by computing again. For example, it can be written as eval+8/eval*4. For example, some segment bits are only 3 bits wide, but the register starts at A0 register, so it can be written as eval+11. |

In addition, because talon will consider negative numbers as illegal addresses, if you need to generate negative numbers, you need to write the expression as "negative number to be assigned + half of the maximum value of the assigned segment". For example, if you assign a value to offset, which is 12 bits, and the maximum value is 2^12, if you need to assign -100, you need to write the expression as "-100 + 2^11".

- If the segment of the register is defined, such as defining the rd register as x1(ra), it should be written as rd([]==1), i.e., the corresponding number of the assignment register can be. However, if you assign a value to csr_reg, you need to write the name of the register, i.e., the column B corresponding to csr_reg in the instrutions.xlsx, regs page

- Constraints can be defined in construction.xlxs, such as the RV32C section of the table tab "computational-U", which has more constraints (see below).

![](assets/Talon_User_Guide/talon_constraint_definition.png)

- If constraints are configured in both the instruction.xlxs and .talon files, the logic with is executed. For example, if c.nop is defined in instruction.xlxs with "nzimm[4:0]([]! =0)" and the constraint "nzimm[4:0]([]==0)" for RV32C is defined in the .talon file. Then, the logical sum of these two constraints is null, i.e., the instruction will not be generated in the generated file.

**Example**:

```
constraint con1 "[]<=2048,[]>1948"    # means that all values are bound to the interval (1948, 2048)

constraint con2 "rd([]! =0|2)"    # means that the rd value cannot be equal to 0 and cannot be equal to 2
```

#### **Randint**

Used to generate a random number of the specified range and assign it to a variable.

**Format**:

​	randint Name Range

**Parameters**:

- Name: The name of the int-type variable to hold the generated random number. The system will add this variable as a global variable.

- Range: the range of the random number generated. randint(a, b), generate random integer in the interval [a-b] (including both ends).

**Example**:

```
randint ran1 [0,3] # Generate a random integer contained in the interval [0,3] and assign it to the global variable ran1.

randint offset_cnt [5]  #It is equivalent to "global offset_cnt = 5", the global variable offset_cnt is defined and assigned the value 5.
```

#### **Test_case**

Used to define a Testcase.

**Format**:

test_case Name Seq ISA_Type

**Parameters**:

- Name: the name of the Testcase variable.

- ISA_Type: list consisting of strings. used to specify the instruction set used by the instructions in this Testcase.


**Description**:

ISA_Type can be []. This scenario is mainly used for illegal instruction testing.

(The [] here actually limits the ISA range for instruction selection)

**Example**:

```
test_case test1 seq ["RV32IMC", "Zicsr", "Vector_alu"] ///include type RV32IMS, Zicsr, Vector_alu instructions (refer to excel)
```

#### **Let**

Used to set the properties of the Testcase.

**Format**:

let Testcase Operate (Target) Value

**Parameters**:

- Testcase: the Testcase variable defined by using test_case.

- Operate: the operation that needs to be performed on the property, the detailed value and description are listed in the table below.

- Target: The operation on the existing object, some operations need this parameter. Refer to the following table for details.

- Value: Set the value of the property, refer to the following table for details.

| **Operate**      | **Target**        | **Value Type**    | **Descriptions**                                             |
| ---------------- | ----------------- | ----------------- | ------------------------------------------------------------ |
| add_dependency   | -                 | Dependency        | Used to add more Dependencies to Testcase. <br />**Example**:<br />`let test1 add_dependency dep1` |
| add_constraint   | Target_constraint | Constraint        | Used to add more Constraint to Testcase's Target_constraint. <br />**Description**: Target_constraint is a constraint added to a specific instruction in a specific ISA.<br />**Format**：Domain >>> ISA_Type >>> instr_segment>>>instr_name<br />(Note that if the corresponding module is not added, then the default will take effect for all) <br />**>>>**：The constraint separator<br />**Domain**：Instruction types, such as L, R, U, C, etc.<br />**ISA_Type**：ISA type, such as RV32I, RV32C, etc.<br />**Instr_segment**：The name of the constrained field.<br />Note that only one pre-defined Constraint can be added at a time.<br />**Example**：Constraint  the range of the s-offset field in the RV32I instruction of type L is the interval (1948, 2048)<br />`constraint con1 "[]<=2048,[]>1948"`<br />`let test1 add_constraint "L>>>RV32I>>>s-offset" con1` |
| set_random_seed  | -                 | Number            | Used to set the seed for Testcase to generate random numbers.<br />**Example**：<br />`let test1 set_random_seed 1234` |
| set_illegal      | -                 | Segment           | Make testcase generate illegal instructions for the specified field (Segment).<br />**Description**：<br />Multiple Segments are separated by ";".<br />When there are multiple Segments, each time an illegal command is generated, one of these Segments is randomly selected as an illegal item. The current illegal command is generated by selecting the correct value for the field after that Segment in the command, except for the variable, and generating the illegal value for the field before (and including). For example, in the command shown in the figure below, "shamt5", "rs1" and "rd" are variables and are not set as illegal command items. Suppose the Segment "func3" is used as an illegal value. Then, the "opcode" Segment after it takes the legal value in the table. The Segments "func3" and "func7" take the values outside the table (i.e., illegal values).<br />**Example**：<br />`let test1 set_illegal "opcode;func3"` |
| enable_warning   | -                 | Bool              | Used to set whether Testcase outputs warning information.<br />As talon will generate a lot of random content in the generation, so the process will generate a lot of warning, close the warning can not produce the corresponding information Note: not case-sensitive, except true, all other is considered false.<br />**Example**：<br />`let test1 enable_warning true`<br />`let test1 enable_warning false` |
| range_opcode_for | Target_sequence   | opcode            | Used to set the current Testcase random selection instruction range.<br />**Description**：Support "with" and "without" keywords.<br />with：Indicates the range of instructions to be generated based on the Target_sequence.<br />without：Indicates that the opcode specified instruction is excluded on top of the Target_sequence.<br />When both with and without are defined, with takes precedence over without and will only refer to the content in with and not look at the content in without.<br />**Example**：<br />`let test1 range_opcode_for "U" "with" "vadd.vv,vsub.vv,vmul.vv"`：In the U list, only vadd.vv,vsub.vv,vmul.vv instructions are generated.<br />`let test2 range_opcode_for "U" "without" "vadd.vv,vsub.vv,vmul.vv"`：In the U list, only instructions other than vadd.vv,vsub.vv,vmul.vv are generated。 |
| add_definition   | Definition key    | Definition value  | Used to add a DefinitionDefinition field (see talon/instruction.xlsx for details) constraint for Testcase.<br />**Example**：<br />`let test1 add_definition "int_type" "16;32"`<br />The above example means that when generating random instructions, we exclude the instructions whose "int_type" value is not equal to "16;32" in the Definition field. In other words, we select all the instructions that do not have "int_type" defined in the Definition field, but have "int_type" defined and equal to "16;32", i.e., we apply only the definition mentioned in add_definition to the existing definition in the instruction.xlsx. |
| add_checkpoint   | Checkpoint type   | Instruction index | Used to add checkpoints in Testcase.<br />Description: Support "at" and "every" keywords.<br/>at n: add a checkpoint to the nth line, a negative number means the number of lines to count down.<br/>erery n: add checkpoints to every n lines of code.<br />**Example**：<br />`let test1 add_checkpoint "at" -3`<br />`let test2 add_checkpoint "every" 4` |

